%!TEX root=../../thesis.tex
%!TEX file=config/commands/typesetting.tex

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% TYPESETTING COMMANDS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%
% @sample \intro{Intro text}: Place a nicely formatted chapter intro
%%
% \DeclareDocumentCommand{\intro}{m}{%
%   \setchapterpreamble[uc][0.85\linewidth]{
%     \begin{spacing}{1.01}%
%       \slshape%
%       #1%
%     \end{spacing}%
%     \bigskip\bigskip%
%   }%
% }


\newenvironment{thesisgoal}{%
  \vspace*{\baselineskip}%
  \noindent\ignorespaces%
  % \hfill
  \begin{adjustwidth}{0.05\linewidth}{0.05\linewidth}%
    % \relsize{1.00}
    \begin{spacing}{1.40}%
      \setlength{\parskip}{0pt}
      \setlength{\parindent}{15pt}
      \slshape%
}{%
      \par\noindent%
      \ignorespacesafterend%
    \end{spacing}%
    \normalfont%
  \end{adjustwidth}%
  % \vspace*{\baselineskip}%
}%



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Todonotes commands
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%
% @sample \comment: Place Blue!20 todo note
% @sample \comment{Additional text}: Place Blue!20 todo note with "Additional text" inside.
% @sample \comment[inline]: Place Blue!20 todo note and pass optional options in brackets to the todo configuration
% @sample \comment[inline]{Additional text}: Place Blue!20 todo note with "Additional text" inside and pass optional options in brackets to the todo configuration.
%%
\ProvideDocumentCommand{\comment}{ s O{} g }{
  \IfNoValueTF{#3}{%
    \todo[color=Blue!40, bordercolor=Blue, #2]{\textbf{Comment!}}%
  }{%
    \todo[color=Blue!40, bordercolor=Blue, prepend, caption={\textbf{Comment!}}, #2]{\color{White}{#3}}%
  }%
  \xspace%
}

%%
% @sample \note: Place Crimson!40 todo note
% @sample \note{Additional text}: Place Crimson!40 todo note with "Additional text" inside.
% @sample \note[inline]: Place Crimson!40 todo note and pass optional options in brackets to the todo configuration
% @sample \note[inline]{Additional text}: Place Crimson!40 todo note with "Additional text" inside and pass optional options in brackets to the todo configuration.
%%
\ProvideDocumentCommand{\note}{ s O{} g }{
  \IfNoValueTF{#3}{%
    \todo[color=Violet!40, bordercolor=Violet, #2]{\textbf{Note!}}%
  }{%
    \todo[color=Violet!40, bordercolor=Violet, prepend, caption={\textbf{Note!}}, #2]{#3}%
  }%
  \xspace%
}

%%
% @sample \addref: Place Orange!40 todo note
% @sample \addref{Additional text}: Place Orange!40 todo note with "Additional text" inside.
% @sample \addref[inline]: Place Orange!40 todo note and pass optional options in brackets to the todo configuration
% @sample \addref[inline]{Additional text}: Place Orange!40 todo note with "Additional text" inside and pass optional options in brackets to the todo configuration.
%%
\ProvideDocumentCommand{\addref}{ s O{} g }{
  \IfNoValueTF{#3}{%
    \todo[color=Orange!40, bordercolor=Orange, #2]{\textbf{Add Reference!}}%
  }{%
    \todo[color=Orange!40, bordercolor=Orange, prepend, caption={\textbf{Add Reference!}}, #2]{#3}%
  }%
  \xspace%
}

%%
% @sample \rewrite: Place Green!40 todo note
% @sample \rewrite{Additional text}: Place Green!40 todo note with "Additional text" inside.
% @sample \rewrite[inline]: Place Green!40 todo note and pass optional options in brackets to the todo configuration
% @sample \rewrite[inline]{Additional text}: Place Green!40 todo note with "Additional text" inside and pass optional options in brackets to the todo configuration.
%%
\ProvideDocumentCommand{\rewrite}{ s O{} g }{%
  \IfNoValueTF{#3}{%
    \todo[color=Green!40, bordercolor=Green, #2]{\textbf{Rewrite!}}%
  }{%
    \todo[color=Green!40, bordercolor=Green, prepend, caption={\textbf{Rewrite!}}, #2]{#3}%
  }%
  \xspace%
}

%%
% @sample \amend: Place Red!40 todo note
% @sample \amend{Additional text}: Place Red!40 todo note with "Additional text" inside.
% @sample \amend[inline]: Place Red!40 todo note and pass optional options in brackets to the todo configuration
% @sample \amend[inline]{Additional text}: Place Red!40 todo note with "Additional text" inside and pass optional options in brackets to the todo configuration.
%%
\ProvideDocumentCommand{\amend}{ s O{} g }{%
  \IfNoValueTF{#3}{%
    \todo[color=Purple!40, bordercolor=Purple, #2]{\textbf{Amend!}}%
  }{%
    \todo[color=Purple!40, bordercolor=Purple, prepend, caption={\textbf{Amend!}}, #2]{\color{White}{#3}}%
  }%
  \xspace%
}

%%
% @sample \correct: Place Red!40 todo note
% @sample \correct{Additional text}: Place Red!40 todo note with "Additional text" inside.
% @sample \correct[inline]: Place Red!40 todo note and pass optional options in brackets to the todo configuration
% @sample \correct[inline]{Additional text}: Place Red!40 todo note with "Additional text" inside and pass optional options in brackets to the todo configuration.
%%
\ProvideDocumentCommand{\correct}{ s O{} g }{%
  \IfNoValueTF{#3}{%
    \todo[color=Red!40, bordercolor=Red, #2]{\textbf{Needs Correction!}}%
  }{%
    \todo[color=Red!40, bordercolor=Red, prepend, caption={\textbf{Needs Correction!}}, #2]{\color{White}{#3}}%
  }%
  \xspace%
}

%%
% @sample \talkabout: Place Gray!40 todo note
% @sample \talkabout{Additional text}: Place Gray!40 todo note with "Additional text" inside.
% @sample \talkabout[inline]: Place Gray!40 todo note and pass optional options in brackets to the todo configuration
% @sample \talkabout[inline]{Additional text}: Place Gray!40 todo note with "Additional text" inside and pass optional options in brackets to the todo configuration.
%%
\ProvideDocumentCommand{\talkabout}{ s O{} m }{%
  \todo[color=Gray!40, bordercolor=Gray, inline, prepend, caption={\textbf{Talk about}}, #2]{{#3}}%
  \xspace%
}

%%
% @sample \question: Place Red!40 question note
% @sample \question{Additional text}: Place Red!40 questin note with "Additional text" inside.
% @sample \question[inline]: Place Red!40 question note and pass optional options in brackets to the todo configuration
% @sample \question[inline]{Additional text}: Place Red!40 question note with "Additional text" inside and pass optional options in brackets to the todo configuration.
%%
\ProvideDocumentCommand{\question}{ s O{} g }{%
  \IfNoValueTF{#3}{%
    \todo[color=Magenta!70, bordercolor=Magenta, #2]{\textbf{Question?}}%
  }{%
    \todo[color=Magenta!70, bordercolor=Magenta, prepend, caption={\textbf{Question?}}, #2]{\color{White}{#3}}%
  }%
  \xspace%
}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% CODE SYNTAX HIGHLIGHTING MACROS
% LaTeX Inline
\newmintinline{latex}{%
  fontsize={\smaller[2]}%
}
% Python inline
\newmintinline{python}{%
}
% Text inline
\newmintinline{text}{%
}
% MATLAB inline
\newmintinline{matlab}{%
}
